//
// Copyright (C) 1999-2004 Toshikaz Hirabayashi
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// TOSHIKAZ HIRABAYASHI BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
//
// Except as contained in this notice, the name of Toshikaz Hirabayashi shall
// not be used in advertising or otherwise to promote the sale, use or other
// dealings in this Software without prior written authorization from
// Toshikaz Hirabayashi.

#include <WScom.h>
#include <WSCRvscrBar.h>
#include <WSCbase.h>
#include <WSCbaseList.h>
#include <WSCvscrBar.h>

WSMFclassInit(WSCRvscrBar,WSCRnwbase);
WSMFremoteClassInit(WSCRvscrBar,WSCvscrBar);

WSCRvscrBar::WSCRvscrBar(){
}

WSCRvscrBar::~WSCRvscrBar(){
}

void WSCRvscrBar::onActivate(){
  if (_local != NULL){
    WSCvscrBar* item = (WSCvscrBar*)_local->cast("WSCvscrBar");
    if (item != NULL){
      item->onActivate();
      return;
    }
  }
  WSCremoteCall rc;
  rc.setClassName("WSCvscrBar");
  rc.setOperationName("onActivate");
  beginRemoteCall(&rc);
  if (_db == NULL){
    return;
  } 
  endRemoteCall();
}
void WSCRvscrBar::onBegin(){
  if (_local != NULL){
    WSCvscrBar* item = (WSCvscrBar*)_local->cast("WSCvscrBar");
    if (item != NULL){
      item->onBegin();
      return;
    }
  }
  WSCremoteCall rc;
  rc.setClassName("WSCvscrBar");
  rc.setOperationName("onBegin");
  beginRemoteCall(&rc);
  if (_db == NULL){
    return;
  } 
  endRemoteCall();
}
void WSCRvscrBar::onEnd(){
  if (_local != NULL){
    WSCvscrBar* item = (WSCvscrBar*)_local->cast("WSCvscrBar");
    if (item != NULL){
      item->onEnd();
      return;
    }
  }
  WSCremoteCall rc;
  rc.setClassName("WSCvscrBar");
  rc.setOperationName("onEnd");
  beginRemoteCall(&rc);
  if (_db == NULL){
    return;
  } 
  endRemoteCall();
}
void WSCRvscrBar::onIncrement(){
  if (_local != NULL){
    WSCvscrBar* item = (WSCvscrBar*)_local->cast("WSCvscrBar");
    if (item != NULL){
      item->onIncrement();
      return;
    }
  }
  WSCremoteCall rc;
  rc.setClassName("WSCvscrBar");
  rc.setOperationName("onIncrement");
  beginRemoteCall(&rc);
  if (_db == NULL){
    return;
  } 
  endRemoteCall();
}
void WSCRvscrBar::onDecrement(){
  if (_local != NULL){
    WSCvscrBar* item = (WSCvscrBar*)_local->cast("WSCvscrBar");
    if (item != NULL){
      item->onDecrement();
      return;
    }
  }
  WSCremoteCall rc;
  rc.setClassName("WSCvscrBar");
  rc.setOperationName("onDecrement");
  beginRemoteCall(&rc);
  if (_db == NULL){
    return;
  } 
  endRemoteCall();
}
void WSCRvscrBar::onPageIncrement(){
  if (_local != NULL){
    WSCvscrBar* item = (WSCvscrBar*)_local->cast("WSCvscrBar");
    if (item != NULL){
      item->onPageIncrement();
      return;
    }
  }
  WSCremoteCall rc;
  rc.setClassName("WSCvscrBar");
  rc.setOperationName("onPageIncrement");
  beginRemoteCall(&rc);
  if (_db == NULL){
    return;
  } 
  endRemoteCall();
}
void WSCRvscrBar::onPageDecrement(){
  if (_local != NULL){
    WSCvscrBar* item = (WSCvscrBar*)_local->cast("WSCvscrBar");
    if (item != NULL){
      item->onPageDecrement();
      return;
    }
  }
  WSCremoteCall rc;
  rc.setClassName("WSCvscrBar");
  rc.setOperationName("onPageDecrement");
  beginRemoteCall(&rc);
  if (_db == NULL){
    return;
  } 
  endRemoteCall();
}
void WSCRvscrBar::onValueChange(){
  if (_local != NULL){
    WSCvscrBar* item = (WSCvscrBar*)_local->cast("WSCvscrBar");
    if (item != NULL){
      item->onValueChange();
      return;
    }
  }
  WSCremoteCall rc;
  rc.setClassName("WSCvscrBar");
  rc.setOperationName("onValueChange");
  beginRemoteCall(&rc);
  if (_db == NULL){
    return;
  } 
  endRemoteCall();
}

void _WSCvscrBar_remote_call(WSDserialize* db,WSCremoteCall* rc){
  if ( rc->_op[0] == 'o'){
    if (!strcmp(rc->_op,"onActivate")){
      WSCbase* inst = WSGIappObjectList()->getInstance(rc->_class,rc->_instance);
      if (inst != NULL){
        WSCvscrBar* item = (WSCvscrBar*)inst->cast("WSCvscrBar");
        if (item != NULL){
          item->onActivate();
        }
      }
      return;
    }else
    if (!strcmp(rc->_op,"onBegin")){
      WSCbase* inst = WSGIappObjectList()->getInstance(rc->_class,rc->_instance);
      if (inst != NULL){
        WSCvscrBar* item = (WSCvscrBar*)inst->cast("WSCvscrBar");
        if (item != NULL){
          item->onBegin();
        }
      }
      return;
    }else
    if (!strcmp(rc->_op,"onEnd")){
      WSCbase* inst = WSGIappObjectList()->getInstance(rc->_class,rc->_instance);
      if (inst != NULL){
        WSCvscrBar* item = (WSCvscrBar*)inst->cast("WSCvscrBar");
        if (item != NULL){
          item->onEnd();
        }
      }
      return;
    }else
    if (!strcmp(rc->_op,"onIncrement")){
      WSCbase* inst = WSGIappObjectList()->getInstance(rc->_class,rc->_instance);
      if (inst != NULL){
        WSCvscrBar* item = (WSCvscrBar*)inst->cast("WSCvscrBar");
        if (item != NULL){
          item->onIncrement();
        }
      }
      return;
    }else
    if (!strcmp(rc->_op,"onDecrement")){
      WSCbase* inst = WSGIappObjectList()->getInstance(rc->_class,rc->_instance);
      if (inst != NULL){
        WSCvscrBar* item = (WSCvscrBar*)inst->cast("WSCvscrBar");
        if (item != NULL){
          item->onDecrement();
        }
      }
      return;
    }else
    if (!strcmp(rc->_op,"onPageIncrement")){
      WSCbase* inst = WSGIappObjectList()->getInstance(rc->_class,rc->_instance);
      if (inst != NULL){
        WSCvscrBar* item = (WSCvscrBar*)inst->cast("WSCvscrBar");
        if (item != NULL){
          item->onPageIncrement();
        }
      }
      return;
    }else
    if (!strcmp(rc->_op,"onPageDecrement")){
      WSCbase* inst = WSGIappObjectList()->getInstance(rc->_class,rc->_instance);
      if (inst != NULL){
        WSCvscrBar* item = (WSCvscrBar*)inst->cast("WSCvscrBar");
        if (item != NULL){
          item->onPageDecrement();
        }
      }
      return;
    }else
    if (!strcmp(rc->_op,"onValueChange")){
      WSCbase* inst = WSGIappObjectList()->getInstance(rc->_class,rc->_instance);
      if (inst != NULL){
        WSCvscrBar* item = (WSCvscrBar*)inst->cast("WSCvscrBar");
        if (item != NULL){
          item->onValueChange();
        }
      }
      return;
    }
  }


extern void _WSCnwbase_remote_call(WSDserialize* db,WSCremoteCall* rc);
  _WSCnwbase_remote_call(db,rc);
}

WSMFdefineDrNetServer(WSCvscrBar,_WSCvscrBar_remote_call);

